/* $Revision Header * Header built automatically - do not edit! *************
 *
 *	(C) Copyright 1991 by Olaf 'Olsen' Barthel & MXM
 *
 *	Name .....: TerminalPanel.c
 *	Created ..: Monday 21-Jan-91 20:12
 *	Revision .: 0
 *
 *	Date            Author          Comment
 *	=========       ========        ====================
 *	21-Jan-91       Olsen           Created this file!
 *
 * $Revision Header ********************************************************/

#include "TermGlobal.h"

enum	{	GAD_FILTER,GAD_DESTRBS,GAD_SWAP,GAD_STRIP,GAD_DISABLE,GAD_RASTER,
		GAD_CR,GAD_LF,GAD_BELL,GAD_SIZE,GAD_COLOUR,GAD_EMULATIONCTRL,
		GAD_EMUNAME,GAD_NEWEMU,GAD_FONT,GAD_USE,GAD_CANCEL,GAD_DEFAULT };

#define WIDTH	449
#define HEIGHT	147

STATIC STRPTR DisplaySizeType[4] =
{
	(STRPTR)"Screen Size",
	(STRPTR)"80  24 (VT100)",
	(STRPTR)"80  25 (ANSI)",
	NULL
};

STATIC STRPTR BellType[5] =
{
	(STRPTR)"Ignore",
	(STRPTR)"Visual",
	(STRPTR)"Audible",
	(STRPTR)"Visual & Audible",
	NULL
};

STATIC STRPTR CRType[4] =
{
	(STRPTR)"Ignore",
	(STRPTR)"As CR",
	(STRPTR)"As CR+LF",
	NULL
};

STATIC STRPTR LFType[4] =
{
	(STRPTR)"Ignore",
	(STRPTR)"As LF",
	(STRPTR)"As LF+CR",
	NULL
};

STATIC STRPTR Emulation[5] =
{
	(STRPTR)"ANSI/VT100",
	(STRPTR)"Atomic",
	(STRPTR)"TTY",
	(STRPTR)"External",
	NULL
};

STATIC STRPTR ColourMode[5] =
{
	(STRPTR)"Amiga",
	(STRPTR)"8 Colours (Blink)",
	(STRPTR)"16 Colours",
	(STRPTR)"Mono",
	NULL
};

STATIC STRPTR Fonts[3] =
{
	(STRPTR)"Topaz",
	(STRPTR)"IBM PC Style",
	NULL
};

	/* TRUE if screen mode limits colour mode. */

STATIC BYTE Limited;

	/* Which item to select for current combination of bell modes. */

STATIC BYTE BellMode;

enum	{	MEN_FILTER=1,MEN_DESTRBS,MEN_SWAP,MEN_STRIP,MEN_DISABLE,MEN_RASTER,
		MEN_CR,MEN_LF,MEN_BELL,MEN_SIZE,MEN_COLOUR,MEN_EMULATIONCTRL,
		MEN_EMUNAME,MEN_NEWEMU,MEN_FONT,MEN_USE,MEN_CANCEL,MEN_DEFAULT };

STATIC struct NewMenu TerminalMenu[] =
{
	{ NM_TITLE, "Project",		 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Capture Filter",	"F", 0, 0, (APTR)MEN_FILTER},
	{  NM_ITEM, "Destructive BS",	"S", 0, 0, (APTR)MEN_DESTRBS},
	{  NM_ITEM, "Swap DEL <-> BS",	"W", 0, 0, (APTR)MEN_SWAP},
	{  NM_ITEM, "Strip Bit 8",	"T", 0, 0, (APTR)MEN_STRIP},
	{  NM_ITEM, "Stop Blinking",	"K", 0, 0, (APTR)MEN_DISABLE},
	{  NM_ITEM, "Raster Enabled",	"A", 0, 0, (APTR)MEN_RASTER},
	{  NM_ITEM, NM_BARLABEL,	 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Send CR",		"R", 0, 0, (APTR)MEN_CR},
	{  NM_ITEM, "Send LF",		"L", 0, 0, (APTR)MEN_LF},
	{  NM_ITEM, "Bell",		"B", 0, 0, (APTR)MEN_BELL},
	{  NM_ITEM, "Display Size",	"Y", 0, 0, (APTR)MEN_SIZE},
	{  NM_ITEM, "Colour",		"O", 0, 0, (APTR)MEN_COLOUR},
	{  NM_ITEM, "Emulation",	"E", 0, 0, (APTR)MEN_EMULATIONCTRL},
	{  NM_ITEM, "Select New Emu.",	"N", 0, 0, (APTR)MEN_NEWEMU},
	{  NM_ITEM, "Font",		"F", 0, 0, (APTR)MEN_FONT},
	{  NM_ITEM, NM_BARLABEL,	 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Use",		"U", 0, 0, (APTR)MEN_USE},
	{  NM_ITEM, "Cancel",		"C", 0, 0, (APTR)MEN_CANCEL},
	{  NM_ITEM, NM_BARLABEL,	 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Quit",		"Q", 0, 0, (APTR)MEN_CANCEL},
	{ NM_END, 0,			 0 , 0, 0, (APTR)0}
};

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget *GadgetArray[],struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		NewGadget . ng_Width		= 26;
		NewGadget . ng_Height		= 12;
		NewGadget . ng_GadgetText	= " Capture F_ilter";
		NewGadget . ng_TextAttr		= &DefaultFont;
		NewGadget . ng_VisualInfo	= VisualInfo;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= (strlen(NewGadget . ng_GadgetText) + 2 - 1) * 8 + 1;
		NewGadget . ng_TopEdge		= 1 + TopEdge;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> CaptureFilter,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Destructive B_S";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> DestructiveBackspace,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "S_wap DEL <-> BS";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> SwapBSDelete,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "S_trip Bit 8";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> StripBit8,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Stop Blin_king";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> DisableBlinking,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "R_aster Enabled";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> RasterEnabled,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Send C_R";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= 1 + TopEdge;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + NewGadget . ng_Width + 8 * (strlen("Display Size") + 2);
		NewGadget . ng_Width		= 164;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	CRType,
			GTCY_Active,	Config -> SendCR,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Send _LF";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	LFType,
			GTCY_Active,	Config -> SendLF,
		TAG_DONE);

		if(Config -> AudibleBell)
		{
			if(Config -> VisibleBell)
				BellMode = 3;
			else
				BellMode = 2;
		}
		else
		{
			if(Config -> VisibleBell)
				BellMode = 1;
			else
				BellMode = 0;
		}

		NewGadget . ng_GadgetText	= "_Bell";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	BellType,
			GTCY_Active,	BellMode,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Displa_y Size";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	DisplaySizeType,
			GTCY_Active,	Config -> EightyColumns,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Col_our";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		switch(Config -> DisplayMode & ~MONITOR_ID_MASK)
		{
			case HIRES_KEY:
			case HIRESLACE_KEY:	Limited = FALSE;
						break;

			default:		Limited = TRUE;
						break;
		}

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	ColourMode,
			GTCY_Active,	Config -> ColourMode,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "_Emulation";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	Emulation,
			GTCY_Active,	Config -> Emulation,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Emu. Name";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	256,
			GTST_String,	Config -> EmulationName,
			GA_Disabled,	Config -> Emulation != EMULATION_EXTERNAL,
			GTST_EditHook,	&CommandHook,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Select _New Emulation";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GA_Disabled,	Config -> Emulation != EMULATION_EXTERNAL,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "_Font";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	Fonts,
			GTCY_Active,	Config -> Font,
			GA_Disabled,	(!IBM || Config -> Emulation == EMULATION_EXTERNAL),
		TAG_DONE);

		NewGadget . ng_Width		= 52;
		NewGadget . ng_Height		= 12;
		NewGadget . ng_GadgetText	= "_Use";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;
		NewGadget . ng_LeftEdge		= 10;
		NewGadget . ng_TopEdge		= HEIGHT - 3 - NewGadget . ng_Height;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= "_Cancel";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= WIDTH - 10 - NewGadget . ng_Width;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);
/*
		NewGadget . ng_GadgetText	= "_Default";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Width		= 60;
		NewGadget . ng_LeftEdge		= (WIDTH - NewGadget . ng_Width) >> 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);*/
	}

	return(Gadget);
}

	/* SelectEmulator(UBYTE *Name,struct Window *ParentWindow):
	 *
	 *	Select a new emulator driver using the
	 *	asl.library file requester.
	 */

STATIC BYTE
SelectEmulator(UBYTE *Name,struct Window *ParentWindow)
{
	struct FileRequester	*AslFileRequest;
	UBYTE			*File,*Temp;
	BYTE			 NewDriver = FALSE;

	File = Name;

	strcpy(SharedBuffer,File);

	Temp = PathPart(SharedBuffer);

	Temp[0] = 0;

	File = FilePart(File);

	if(AslFileRequest = (struct FileRequester *)AllocAslRequestTags(ASL_FileRequest,
		ASL_Window,	ParentWindow,
		ASL_File,	File,
		ASL_Dir,	SharedBuffer,
		ASL_Hail,	"Select Emulator",
		ASL_FuncFlags,	0,
		ASL_Pattern,	"#?.XEM",
		ASL_OKText,	"Select",
	TAG_END))
	{
		if(AslRequestTags(AslFileRequest,TAG_DONE))
		{
			if(AslFileRequest -> rf_File[0])
			{
				strcpy(SharedBuffer,AslFileRequest -> rf_Dir);

				if(!AddPart(SharedBuffer,AslFileRequest -> rf_File,256))
					strcpy(SharedBuffer,AslFileRequest -> rf_File);

				if(Stricmp(SharedBuffer,Name))
				{
					strcpy(Name,SharedBuffer);

					NewDriver = TRUE;
				}
			}
		}

		FreeAslRequest(AslFileRequest);
	}

	return(NewDriver);
}

VOID
TerminalPanel(struct Configuration *Config)
{
	struct Window	*PanelWindow;
	struct Menu	*PanelMenu;
	struct Gadget	*GadgetList = NULL;
	struct Gadget	*GadgetArray[GAD_CANCEL + 1];
	LONG		 Value;
	UBYTE		 DummyBuffer[256];

	CopyMem(Config,&PrivateConfig,sizeof(struct Configuration));

	if(CreateAllGadgets(Config,&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
	{
		if(PanelMenu = CreateMenus(TerminalMenu,
			GTMN_FrontPen, 0,
		TAG_DONE))
		{
			if(LayoutMenus(PanelMenu,VisualInfo,
				GTMN_TextAttr,&DefaultFont,
			TAG_DONE))
			{
				if(PanelWindow = OpenWindowTags(NULL,
					WA_Left,	(Screen -> Width - WIDTH) >> 1,
					WA_Top,		(Screen -> Height - HEIGHT) >> 1,
					WA_Width,	WIDTH,
					WA_Height,	HEIGHT,

					WA_Activate,	TRUE,
					WA_DragBar,	TRUE,
					WA_DepthGadget,	TRUE,
					WA_RMBTrap,	TRUE,
					WA_DepthGadget,	TRUE,
					WA_CloseGadget,	TRUE,
					WA_CustomScreen,Screen,

					WA_IDCMP,	IDCMP_CLOSEWINDOW | SLIDERIDCMP | CHECKBOXIDCMP | LISTVIEWIDCMP | IDCMP_MENUPICK,

					WA_Title,	"Terminal Preferences",
				TAG_DONE))
				{
					struct IntuiMessage	*Massage;
					ULONG			 Class,Code;
					struct Gadget		*Gadget;
					BYTE			 Terminated = FALSE;

					PushWindow(PanelWindow);

					AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
					RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
					GT_RefreshWindow(PanelWindow,NULL);

					SetMenuStrip(PanelWindow,PanelMenu);

					if(Config -> Emulation != EMULATION_EXTERNAL)
						OffMenu(PanelWindow,FULLMENUNUM(0,13,0));

					PanelWindow -> Flags &= ~WFLG_RMBTRAP;

					if(!(GadgetArray[GAD_EMUNAME] -> Flags & GFLG_DISABLED))
					{
						ActivateGadget(GadgetArray[GAD_EMUNAME],PanelWindow,NULL);

						ActiveGadget = GadgetArray[GAD_EMUNAME];
					}

					while(!Terminated)
					{
						WaitPort(PanelWindow -> UserPort);

						while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
						{
							Class	= Massage -> Class;
							Code	= Massage -> Code;
							Gadget	= (struct Gadget *)Massage -> IAddress;

							GT_ReplyIMsg(Massage);

							if(Class == IDCMP_GADGETDOWN)
							{
								if((Gadget -> GadgetType & GTYP_GTYPEMASK) == STRGADGET)
									ActiveGadget = Gadget;
							}

							if(Class == IDCMP_ACTIVEWINDOW && ActiveGadget)
								ActivateGadget(ActiveGadget,PanelWindow,NULL);

							if(Class == IDCMP_RAWKEY)
							{
								if(Code == IECODE_UP_PREFIX|103 && CommandWindow == PanelWindow)
									ActivateGadget(CommandGadget,PanelWindow,NULL);
							}

							if(Class == IDCMP_MENUPICK)
							{
								struct MenuItem *MenuItem;

								while(Code != MENUNULL)
								{
									MenuItem = ItemAddress(PanelMenu,Code);

									switch((ULONG)GTMENUITEM_USERDATA(MenuItem))
									{
										case MEN_FILTER:	GT_SetGadgetAttrs(GadgetArray[GAD_FILTER],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_FILTER] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_DESTRBS:	GT_SetGadgetAttrs(GadgetArray[GAD_DESTRBS],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_DESTRBS] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_SWAP:		GT_SetGadgetAttrs(GadgetArray[GAD_SWAP],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_SWAP] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_STRIP:		GT_SetGadgetAttrs(GadgetArray[GAD_STRIP],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_STRIP] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_DISABLE:		GT_SetGadgetAttrs(GadgetArray[GAD_DISABLE],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_DISABLE] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_RASTER:		GT_SetGadgetAttrs(GadgetArray[GAD_RASTER],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_RASTER] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_CR:		Value = (Config -> SendCR + 1) % 3;

													GT_SetGadgetAttrs(GadgetArray[GAD_CR],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_CR];
													Code = Value;

													goto GadCheck;

										case MEN_LF:		Value = (Config -> SendLF + 1) % 3;

													GT_SetGadgetAttrs(GadgetArray[GAD_LF],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_LF];
													Code = Value;

													goto GadCheck;

										case MEN_BELL:		BellMode = (BellMode + 1) % 4;

													GT_SetGadgetAttrs(GadgetArray[GAD_BELL],PanelWindow,NULL,
														GTCY_Active,BellMode,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_BELL];
													Code = BellMode;

													goto GadCheck;

													break;

										case MEN_SIZE:		Value = (Config -> EightyColumns + 1) % 3;

													GT_SetGadgetAttrs(GadgetArray[GAD_SIZE],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_SIZE];
													Code = Value;

													goto GadCheck;

										case MEN_COLOUR:	Value = (Config -> ColourMode + 1) % 4;

													GT_SetGadgetAttrs(GadgetArray[GAD_COLOUR],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_COLOUR];
													Code = Value;

													goto GadCheck;

										case MEN_EMULATIONCTRL:	Value = (Config -> Emulation + 1) % 4;

													GT_SetGadgetAttrs(GadgetArray[GAD_EMULATIONCTRL],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_EMULATIONCTRL];
													Code = Value;

													goto GadCheck;

										case MEN_NEWEMU:		Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_NEWEMU];
													break;

										case MEN_FONT:		if(Config -> Font == FONT_TOPAZ && IBM)
														Value = FONT_IBM;
													else
														Value = FONT_TOPAZ;

													GT_SetGadgetAttrs(GadgetArray[GAD_FONT],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_FONT];
													Code = Value;

													goto GadCheck;

										case MEN_USE:		Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_USE];
													break;

										case MEN_CANCEL:	Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_CANCEL];
													break;

										default:		break;
									}

									Code = MenuItem -> NextSelect;
								}

								if(ActiveGadget)
									ActivateGadget(ActiveGadget,PanelWindow,NULL);
							}

							if(Class == IDCMP_CLOSEWINDOW)
								Terminated = TRUE;

GadCheck:						if(Class == IDCMP_GADGETUP)
							{
								switch(Gadget -> GadgetID)
								{
									case GAD_CR:		Config -> SendCR = Code;
												break;

									case GAD_LF:		Config -> SendLF = Code;
												break;

									case GAD_BELL:		BellMode = Code;

												switch(BellMode)
												{
													case 0:	Config -> VisibleBell	= FALSE;
														Config -> AudibleBell	= FALSE;
														break;

													case 1:	Config -> VisibleBell	= TRUE;
														Config -> AudibleBell	= FALSE;
														break;

													case 2:	Config -> VisibleBell	= FALSE;
														Config -> AudibleBell	= TRUE;
														break;

													case 3:	Config -> VisibleBell	= TRUE;
														Config -> AudibleBell	= TRUE;
														break;
												}

												break;

									case GAD_SIZE:	Config -> EightyColumns = Code;
												break;

									case GAD_COLOUR:	Config -> ColourMode = Code;

												if(Code > COLOUR_AMIGA && (Config -> Emulation == EMULATION_ATOMIC || Limited))
												{
													GT_SetGadgetAttrs(GadgetArray[GAD_COLOUR],PanelWindow,NULL,
														GTCY_Active,COLOUR_MONO,
													TAG_DONE);

													Config -> ColourMode = COLOUR_MONO;
												}

												break;

									case GAD_EMULATIONCTRL:	Config -> Emulation = Code;

												if(Code == EMULATION_ATOMIC && Config -> ColourMode != COLOUR_AMIGA && Config -> ColourMode != COLOUR_MONO)
												{
													GT_SetGadgetAttrs(GadgetArray[GAD_COLOUR],PanelWindow,NULL,
														GTCY_Active,COLOUR_MONO,
													TAG_DONE);

													Config -> ColourMode = COLOUR_MONO;
												}

												GT_SetGadgetAttrs(GadgetArray[GAD_EMUNAME],PanelWindow,NULL,
													GA_Disabled,	Config -> Emulation != EMULATION_EXTERNAL,
												TAG_DONE);

												GT_SetGadgetAttrs(GadgetArray[GAD_NEWEMU],PanelWindow,NULL,
													GA_Disabled,	Config -> Emulation != EMULATION_EXTERNAL,
												TAG_DONE);

												if(IBM)
												{
													GT_SetGadgetAttrs(GadgetArray[GAD_FONT],PanelWindow,NULL,
														GA_Disabled,	Config -> Emulation == EMULATION_EXTERNAL,
													TAG_DONE);
												}

												if(Config -> Emulation == EMULATION_EXTERNAL)
												{
													OnMenu(PanelWindow,FULLMENUNUM(0,13,0));

													ActivateGadget(GadgetArray[GAD_EMUNAME],PanelWindow,NULL);

													ActiveGadget = GadgetArray[GAD_EMUNAME];
												}
												else
												{
													OffMenu(PanelWindow,FULLMENUNUM(0,13,0));

													ActiveGadget = NULL;
												}

												break;

									case GAD_FONT:		Config -> Font = Code;
												break;

									case GAD_USE:		Terminated = TRUE;

												Config -> CaptureFilter		= GadgetArray[GAD_FILTER] -> Flags & GFLG_SELECTED;
												Config -> DestructiveBackspace	= GadgetArray[GAD_DESTRBS] -> Flags & GFLG_SELECTED;
												Config -> SwapBSDelete		= GadgetArray[GAD_SWAP] -> Flags & GFLG_SELECTED;
												Config -> StripBit8		= GadgetArray[GAD_STRIP] -> Flags & GFLG_SELECTED;
												Config -> DisableBlinking	= GadgetArray[GAD_DISABLE] -> Flags & GFLG_SELECTED;
												Config -> RasterEnabled		= GadgetArray[GAD_RASTER] -> Flags & GFLG_SELECTED;

												strcpy(Config -> EmulationName,((struct StringInfo *)GadgetArray[GAD_EMUNAME] -> SpecialInfo) -> Buffer);

												switch(Config -> ColourMode)
												{
													case COLOUR_EIGHT:	CopyMem(&ANSIColours[0],&Config -> Colours[0],16 * sizeof(UWORD));
																break;

													case COLOUR_SIXTEEN:	CopyMem(&EGAColours[0],&Config -> Colours[0],16 * sizeof(UWORD));
																break;

													case COLOUR_AMIGA:	CopyMem(&DefaultColours[0],&Config -> Colours[0],16 * sizeof(UWORD));
																break;

													case COLOUR_MONO:		CopyMem(&AtomicColours[0],&Config -> Colours[0],16 * sizeof(UWORD));
																break;
												}

												break;

									case GAD_NEWEMU:	strcpy(DummyBuffer,((struct StringInfo *)GadgetArray[GAD_EMUNAME] -> SpecialInfo) -> Buffer);

												SetWait(PanelWindow);

												PanelWindow -> Flags |= WFLG_RMBTRAP;

												if(SelectEmulator(DummyBuffer,PanelWindow))
												{
													GT_SetGadgetAttrs(GadgetArray[GAD_EMUNAME],PanelWindow,NULL,
														GTST_String,DummyBuffer,
													TAG_DONE);
												}

												ClearPointer(PanelWindow);
												PanelWindow -> Flags &= ~WFLG_RMBTRAP;

												break;

									case GAD_CANCEL:	Terminated = TRUE;

												CopyMem(&PrivateConfig,Config,sizeof(struct Configuration));

												break;

									default:		break;
								}
							}
						}
					}

					PanelWindow -> Flags |= WFLG_RMBTRAP;

					ClearMenuStrip(PanelWindow);

					RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

					PopWindow();

					CloseWindow(PanelWindow);
				}
			}

			FreeMenus(PanelMenu);
		}
	}

	FreeGadgets(GadgetList);
}
